#version 330

uniform mat4 projMatrix;
uniform mat4 modelMatrix;
uniform float explosionTime;
uniform int explosionIdx;
uniform float explosionRad;

layout(location = 0) in vec2 in_Vertex; // 0
layout(location = 1) in vec4 in_Color; // 1

out vec4 ex_Color;

void main(void)
{
    ex_Color = in_Color * (gl_VertexID - explosionIdx) / 1025.0;

    gl_PointSize = 10.0;

    vec2 pos = in_Vertex * explosionRad * explosionTime;
    gl_Position = projMatrix * modelMatrix * vec4(pos, 0.0f, 1.0);
}
