#version 330

uniform mat4 projMatrix;
uniform mat4 modelMatrix;
uniform mat4 textureMatrix;
uniform mat3 normalMatrix;

layout(location = 0) in vec3 in_Vertex; // 0
layout(location = 1) in vec3 in_TexCoord; // 1
layout(location = 2) in vec3 in_Normal; // 2
layout(location = 3) in vec4 in_Color; // 3

out vec3 ex_TexCoord;
out vec4 ex_Color;

out vec3 ex_Normal;
out vec3 ex_Vertex;

void main(void)
{
    ex_TexCoord = vec3(textureMatrix * vec4(in_TexCoord,1.0));
    ex_Color = in_Color;

    ex_Normal = normalize(normalMatrix * in_Normal);
    ex_Vertex = vec3(modelMatrix * vec4(in_Vertex, 1.0));

    gl_Position = projMatrix * modelMatrix * vec4(in_Vertex, 1.0);
}
